<template>
<div>
  <router-view></router-view>
  <notifications group="foo" />
</div>
  
  
</template>

<script>
import { socket } from "@/services/socket.js";
import { store } from "./stores/store.js";
// import {
//   socket
// } from '@/services/socket.js'
import { event, forceReloadWindow } from "@/utils";
// import {
//   userStore
// } from '@/stores/user'

export default {
  name: "app",
  data() {
    return {
      authenticated: false,
      user: {}
    };
  },
  mounted() {
    const token = localStorage.getItem("token");
    if (token) {
      this.authenticated = true;
      this.init();
    }
  },
  created() {
    event.on({
      /**
       * Log the current user out and reset the application state.
       */
      async logout() {
        localStorage.removeItem("token");
        forceReloadWindow();
        // this.logout()
        // ls.remove('jwt-token')
        // console.log('a')
        // this.$store.dispatch('logout')
      },
      login: () => {
        this.authenticated = true;
        ///this.user = store.state.user;
      }
    });
  },
  methods: {
    async init() {
      await socket.init();
      // Make the most important HTTP request to get all necessary data from the server.
      // Afterwards, init all mandatory stores and services.
      try {
        // Let all other components know we're ready.
        event.emit("app:ready");
      } catch (err) {
        this.authenticated = false;
      }
    },
    onUserLoggedIn() {
      this.authenticated = true;
      self.$root.user = this.$store.status;
      this.init();
    },
    onLogout() {
      this.store.dispatch("logout").then(() => {
        this.$router.push("/login");
      });
    },
    listenForChanges() {
      socket.listen("PaymentCreated", e => {
        this.$notify({
          group: "foo",
          title: "Thông báo",
          text: "Một giao dịch mới được tạo",
          position: "top right"
        });
      });
    }
  }
};
</script>

<style lang="scss">
// CoreUI Icons Set
@import "~@coreui/icons/css/coreui-icons.min.css";
/* Import Font Awesome Icons Set */
$fa-font-path: "~font-awesome/fonts/";
@import "~font-awesome/scss/font-awesome.scss";
/* Import Simple Line Icons Set */
$simple-line-font-path: "~simple-line-icons/fonts/";
@import "~simple-line-icons/scss/simple-line-icons.scss";
/* Import Flag Icons Set */
@import "~flag-icon-css/css/flag-icon.min.css";
/* Import Bootstrap Vue Styles */
@import "~bootstrap-vue/dist/bootstrap-vue.css";
// Import Main styles for this application
@import "assets/scss/style";
</style>
